using System;
using System.Runtime.InteropServices;
using System.Text;

/// <summary>
/// C# Class for NTPort Library
/// Copyright  1997-2002 Hai Li, Zeal SoftStudio.
/// E-Mail: support@zealsoftstudio.com
/// Web: http://www.zealsoftstudio.com
/// </summary>
namespace ZealSoftStudio.NTPort
{
	public class NTPort
	{
		// Returns a value indicating the last operation is successful or not.
		// int WINAPI GetLastState(char *s);
		[ DllImport( "Ntport.dll", EntryPoint="GetLastState", CharSet=CharSet.Auto )]
		public static extern int GetLastState( 
			[MarshalAs(UnmanagedType.LPStr)] StringBuilder sError );

		// Enable your application to read or write specific ports.
		// void WINAPI EnablePorts(WORD PortStart, WORD PortStop);
		[ DllImport( "Ntport.dll", EntryPoint="EnablePorts", CharSet=CharSet.Auto )]
		public static extern void EnablePorts(short nPortStart, short nPortStop);

		// Disable your application to read or write specific ports.
		// void WINAPI DisablePorts(WORD PortStart, WORD PortStop);
		[ DllImport( "Ntport.dll", EntryPoint="DisablePorts", CharSet=CharSet.Auto )]
		public static extern void DisablePorts(short nPortStart, short nPortStop);

		// Returns a value indicates whether the application is running under Windows NT/2000 system.
		// BOOL WINAPI IsWinNT();
		[ DllImport( "Ntport.dll", EntryPoint="IsWinNT", CharSet=CharSet.Auto )]
		public static extern bool IsWinNT();

		// Returns a value from specific ports.
		// WORD WINAPI Inport(WORD PortNum);
		[ DllImport( "Ntport.dll", EntryPoint="Inport", CharSet=CharSet.Auto )]
		public static extern byte Inport( short nPortAddress );
		// WORD WINAPI Inp(WORD PortNum);
		[ DllImport( "Ntport.dll", EntryPoint="Inp", CharSet=CharSet.Auto )]
		public static extern byte Inp( short nPortAddress );	
		// WORD WINAPI Inpw(WORD PortNum);
		[ DllImport( "Ntport.dll", EntryPoint="Inpw", CharSet=CharSet.Auto )]
		public static extern short Inpw( short nPortAddress );
		// WORD WINAPI InportW(WORD PortNum);
		[ DllImport( "Ntport.dll", EntryPoint="InportW", CharSet=CharSet.Auto )]
		public static extern short InportW( short nPortAddress );
		// DWORD WINAPI Inpd(WORD PortNum);
		[ DllImport( "Ntport.dll", EntryPoint="Inpd", CharSet=CharSet.Auto )]
		public static extern short Inpd( short nPortAddress );
		//DWORD WINAPI InportD(WORD PortNum);
		[ DllImport( "Ntport.dll", EntryPoint="InportD", CharSet=CharSet.Auto )]
		public static extern int InportD( short nPortAddress );
	
		// Write a value to specific ports.
		// void WINAPI Outp(WORD PortNum, WORD Data);
		[ DllImport( "Ntport.dll", EntryPoint="Outp", CharSet=CharSet.Auto )]
		public static extern void Outp( short nPortAddress, short nData);
		// void WINAPI Outport(WORD PortNum, WORD Data);
		[ DllImport( "Ntport.dll", EntryPoint="Outport", CharSet=CharSet.Auto )]
		public static extern void Outport( short nPortAddress, short nData);
		// void WINAPI Outpw(WORD PortNum, WORD Data);
		[ DllImport( "Ntport.dll", EntryPoint="Outpw", CharSet=CharSet.Auto )]
		public static extern void Outpw( short nPortAddress, short nData);
		// void WINAPI OutportW(WORD PortNum, WORD Data);
		[ DllImport( "Ntport.dll", EntryPoint="OutportW", CharSet=CharSet.Auto )]
		public static extern void OutportW( short nPortAddress, short nData);
		// void WINAPI Outpd(WORD PortNum, DWORD Data);
		[ DllImport( "Ntport.dll", EntryPoint="Outpd", CharSet=CharSet.Auto )]
		public static extern void Outpd( short nPortAddress, int nData);
		// void WINAPI OutportD(WORD PortNum, DWORD Data);
		[ DllImport( "Ntport.dll", EntryPoint="OutportD", CharSet=CharSet.Auto )]
		public static extern void OutportD( short nPortAddress, int nData);

		// Set the registration information.
		// void WINAPI LicenseInfo(LPSTR sUserName, DWORD dwKey);
		[ DllImport( "Ntport.dll", EntryPoint="LicenseInfo", CharSet=CharSet.Auto )]
		public static extern void LicenseInfo(
			[MarshalAs(UnmanagedType.LPStr)]String sUserName, int dwKey);

		// Returns the version of NTPort Library.
		// WORD WINAPI GetNTPortVersion();
		[ DllImport( "Ntport.dll", EntryPoint="GetNTPortVersion", CharSet=CharSet.Auto )]
		public static extern short GetNTPortVersion();

		// Set the setting of fast mode
		// void WINAPI SetFastMode(BOOL bOption);
		[ DllImport( "Ntport.dll", EntryPoint="SetFastMode", CharSet=CharSet.Auto )]
		public static extern void SetFastMode(bool bOption);

		// Get the current setting of fast mode
		// BOOL WINAPI GetFastMode();
		[ DllImport( "Ntport.dll", EntryPoint="GetFastMode", CharSet=CharSet.Auto )]
		public static extern bool GetFastMode();

		// Get the base address of LPT port
		// WORD WINAPI GetLPTPortAddress(WORD PortNo);
		[ DllImport( "Ntport.dll", EntryPoint="GetLPTPortAddress", CharSet=CharSet.Auto )]
		public static extern short GetLPTPortAddress(short nPortNo);

		public const int ERROR_NONE = 0;
		public const int ERROR_DRIVER = 2;
		public const int ERROR_SCM_CANT_CONNECT = 9998;

		public NTPort()
		{
			//
			// TODO: Add constructor logic here
			//
		}
	}
}