using System;
using System.Diagnostics;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using ZealSoftStudio.NTPort;

namespace SampleLPTApp
{
	/// <summary>
	/// Summary description for LPTSampleAppForm.
	/// </summary>
	public class LPTSampleAppForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox comboBoxPorts;
		private System.Windows.Forms.TextBox textBoxData;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.RadioButton radioButtonByte;
		private System.Windows.Forms.RadioButton radioButtonDWord;
		private System.Windows.Forms.RadioButton radioButtonWord;
		private System.Windows.Forms.Button buttonWrite;
		private System.Windows.Forms.Button buttonExit;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LPTSampleAppForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// Add any constructor code after InitializeComponent call
			//
			NTPort.LicenseInfo("NAME", 0);
			EnumeratePorts();
		}

		private void EnumeratePorts()
		{
			ZealSoftStudio.NTPort.LPTPort lpt;

			comboBoxPorts.Items.Clear();
			try
			{
				lpt = new LPTPort(LPTPort.Ports.LPT1);
				comboBoxPorts.Items.Add("LPT1");
			}
			catch(Exception e)
			{
				Debug.WriteLine("LPTSampleAppForm Warning: " + e.Message);
			}

			try
			{
				lpt = new LPTPort(LPTPort.Ports.LPT2);
				comboBoxPorts.Items.Add("LPT2");
			}
			catch(Exception e)
			{
				Debug.WriteLine("LPTSampleAppForm Warning: " + e.Message);
			}

			try
			{
				lpt = new LPTPort(LPTPort.Ports.LPT3);
				comboBoxPorts.Items.Add("LPT3");
			}
			catch(Exception e)
			{
				Debug.WriteLine("LPTSampleAppForm Warning: " + e.Message);
			}

			if (comboBoxPorts.Items.Count>0)
			{
				comboBoxPorts.SelectedIndex = 0;
			}
			else
			{
				buttonWrite.Enabled = false;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.buttonWrite = new System.Windows.Forms.Button();
			this.label1 = new System.Windows.Forms.Label();
			this.comboBoxPorts = new System.Windows.Forms.ComboBox();
			this.textBoxData = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.radioButtonByte = new System.Windows.Forms.RadioButton();
			this.radioButtonDWord = new System.Windows.Forms.RadioButton();
			this.radioButtonWord = new System.Windows.Forms.RadioButton();
			this.buttonExit = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// buttonWrite
			// 
			this.buttonWrite.Location = new System.Drawing.Point(144, 136);
			this.buttonWrite.Name = "buttonWrite";
			this.buttonWrite.TabIndex = 0;
			this.buttonWrite.Text = "&Write It!";
			this.buttonWrite.Click += new System.EventHandler(this.buttonWrite_Click);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(12, 12);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(124, 16);
			this.label1.TabIndex = 1;
			this.label1.Text = "Available Parallel Ports";
			// 
			// comboBoxPorts
			// 
			this.comboBoxPorts.Items.AddRange(new object[] {
															   "EMPTY - FILLED AT RUNTIME"});
			this.comboBoxPorts.Location = new System.Drawing.Point(12, 32);
			this.comboBoxPorts.Name = "comboBoxPorts";
			this.comboBoxPorts.Size = new System.Drawing.Size(108, 21);
			this.comboBoxPorts.TabIndex = 5;
			// 
			// textBoxData
			// 
			this.textBoxData.Location = new System.Drawing.Point(12, 92);
			this.textBoxData.Name = "textBoxData";
			this.textBoxData.Size = new System.Drawing.Size(108, 20);
			this.textBoxData.TabIndex = 1;
			this.textBoxData.Text = "0";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(12, 72);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(108, 16);
			this.label2.TabIndex = 4;
			this.label2.Text = "Data to write";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(12, 120);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 16);
			this.label3.TabIndex = 5;
			this.label3.Text = "Data Mode";
			// 
			// radioButtonByte
			// 
			this.radioButtonByte.Checked = true;
			this.radioButtonByte.Location = new System.Drawing.Point(12, 136);
			this.radioButtonByte.Name = "radioButtonByte";
			this.radioButtonByte.Size = new System.Drawing.Size(64, 20);
			this.radioButtonByte.TabIndex = 2;
			this.radioButtonByte.TabStop = true;
			this.radioButtonByte.Text = "BYTE";
			// 
			// radioButtonDWord
			// 
			this.radioButtonDWord.Location = new System.Drawing.Point(12, 176);
			this.radioButtonDWord.Name = "radioButtonDWord";
			this.radioButtonDWord.Size = new System.Drawing.Size(68, 20);
			this.radioButtonDWord.TabIndex = 4;
			this.radioButtonDWord.Text = "DWORD";
			// 
			// radioButtonWord
			// 
			this.radioButtonWord.Location = new System.Drawing.Point(12, 156);
			this.radioButtonWord.Name = "radioButtonWord";
			this.radioButtonWord.Size = new System.Drawing.Size(64, 20);
			this.radioButtonWord.TabIndex = 3;
			this.radioButtonWord.Text = "WORD";
			// 
			// buttonExit
			// 
			this.buttonExit.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonExit.Location = new System.Drawing.Point(144, 172);
			this.buttonExit.Name = "buttonExit";
			this.buttonExit.TabIndex = 6;
			this.buttonExit.Text = "E&xit";
			this.buttonExit.Click += new System.EventHandler(this.buttonExit_Click);
			// 
			// LPTSampleAppForm
			// 
			this.AcceptButton = this.buttonWrite;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonExit;
			this.ClientSize = new System.Drawing.Size(236, 210);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.buttonExit,
																		  this.radioButtonWord,
																		  this.radioButtonDWord,
																		  this.radioButtonByte,
																		  this.label3,
																		  this.label2,
																		  this.textBoxData,
																		  this.comboBoxPorts,
																		  this.label1,
																		  this.buttonWrite});
			this.Name = "LPTSampleAppForm";
			this.Text = "LPT Class Sample Application";
			this.Load += new System.EventHandler(this.LPTSampleAppForm_Load);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new LPTSampleAppForm());
		}

		private void LPTSampleAppForm_Load(object sender, System.EventArgs e)
		{
		}

		private void buttonWrite_Click(object sender, System.EventArgs e)
		{
			try
			{
				LPTPort lpt = new LPTPort(GetPortFromForm());
				if (radioButtonByte.Checked)
				{
					lpt.Output(Convert.ToByte(textBoxData.Text));
				}
				else if (radioButtonWord.Checked)
				{
					lpt.Output(Convert.ToInt16(textBoxData.Text));
				}
				else
				{
					lpt.Output(Convert.ToInt32(textBoxData.Text));
				}
			}
			catch(Exception ex)
			{
				MessageBox.Show("Error writing to port.\n\nDetails:\n" + ex.ToString(),"LPT Sample App Error",MessageBoxButtons.OK,MessageBoxIcon.Error);
			}
		}

		LPTPort.Ports GetPortFromForm()
		{
			LPTPort.Ports port = LPTPort.Ports.LPT1;
			switch(comboBoxPorts.SelectedItem.ToString())
			{
				case "LPT1":
					port = LPTPort.Ports.LPT1;  
					break;
				case "LPT2":
					port = LPTPort.Ports.LPT2;
					break;
				case "LPT3":
					port = LPTPort.Ports.LPT3;
					break;
			}
			return port;
		}

		private void buttonExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}
	}
}
